class VBWidgetPlugin(QtDesigner.QPyDesignerCustomWidgetPlugin):
    """
    VBWidgetPlugin(QtDesigner.QPyDesignerCustomWidgetPlugin)

    Provides a Python custom VBWidget plugin for Qt Designer by implementing the
    VBWidgetPlugin via a PyQt-specific custom plugin class.
    """

    create_property = QtCore.pyqtSignal(QtCore.QObject)

    def __init__(self, parent=None):
        super(VBWidgetPlugin, self).__init__(parent)
        self.initialized = False
        self.factory = None
        self.manager = None
        self.button = None
        self.property_manager = None
        self.create_property.connect(self.identify)

    def initialize(self, formEditor):
        if self.initialized:
            return
            
        self.property_manager = formEditor.propertyEditor()
        if self.manager:
            self.factory = VBWidgetExtensionFactory(self.manager)
            self.manager.registerExtensions(self.factory, Q_TYPEID['QPyDesignerPropertySheetExtension'])
        self.initialized = True

    def isInitialized(self):
        return self.initialized

    def createWidget(self, parent):
        self.widget = VBWidget(parent)
        self.widget.installEventFilter(self)
        return self.widget
